//====================================================
// Grande
// Copyright (C) 2001, kacchan
// E-M@il address   fc3srx@mwnet.or.jp
// Homepage address http://www2.mwnet.or.jp/~fc3srx7
//====================================================
#ifndef _GRANDE_H_
#define _GRANDE_H_

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <unistd.h>
#include <KXL.h>

// 
#define RM(n) (rand() % (n))

// SGN
#define SGN(n) ((n < 0) ? -1 : (n > 0) ? 1 : 0)

// ե졼졼
#define FRAME_RATE 30

// ɥ
#define FREE       96                  // ;
#define WIDTH      384                 // 
#define HEIGHT     320                 // ⤵
#define UP_LEFT    FREE                // 躸
#define UP_TOP     FREE                // 
#define UP_RIGHT   (FREE + WIDTH - 1)  // 豦
#define UP_BOTTOM  (FREE + HEIGHT -1)  // 褷
#define PIC_WIDTH  (FREE * 2 + WIDTH)  // ե졼Хåե
#define PIC_HEIGHT (FREE * 2 + HEIGHT) // ե졼Хåե⤵

// Ϣ
#define KeyUp    KXL_KEY_Up
#define KeyDown  KXL_KEY_Down
#define KeyRight KXL_KEY_Right
#define KeyLeft  KXL_KEY_Left
#define KeyShot  KXL_KEY_z
#define KeySShot KXL_KEY_Shift_L
#define KeyPause KXL_KEY_s
#define KeyQuit  KXL_KEY_Escape

#define KNone      0
#define KUp        (1L << 0)
#define KDown      (1L << 1)
#define KRight     (1L << 2)
#define KLeft      (1L << 3)
#define KShot      (1L << 4)
#define KSShot     (1L << 5)
#define KPause     (1L << 6)
#define KQuit      (1L << 7)

#define KUpMask    ~KUp
#define KDownMask  ~KDown
#define KRightMask ~KRight
#define KLeftMask  ~KLeft
#define KShotMask  ~KShot
#define KSShotMask ~KSShot
#define KPauseMask ~KPause
#define KQuitMask  ~KQuit

// 饯μ̻
#define AttrNone     0          // ʤ
#define AttrMy       (1L << 0)  // 
#define AttrMShot    (1L << 1)  // Ũ
#define AttrMBomb    (1L << 2)  // Ũ
#define AttrEnemy    (1L << 3)  // Ũ
#define AttrEShot    (1L << 4)  // Ũ
#define AttrEBomb    (1L << 5)  // 
#define AttrItem     (1L << 6)  // ƥ
#define AttrShadow   (1L << 7)  // 

// ϰ(᡼85%)
#define CHECK_PER    0.85

// 饯
#define MAX_YOUR    200
#define MAX_MY      80
#define MY_NO       MAX_MY - 2
#define ARM_NO      MAX_MY - 1
#define BOSS_NO     0

// 
enum {
  SE_POW = 0,
  SE_BOMB,
  SE_SHOT,
  SE_GO,
  SE_MBOMB
};

// ᥤư
typedef enum {
  MainKXL = 0,
  MainOpening,
  MainStart,
  MainGame,
  MainClear,
  MainGameOver,
  MainEnding,
  MainPause
} MainEnum;

// ư
typedef enum {
  RcHitNone,
  RcHitDel,
  RcHitBomb,
  RcHitBoss
} RcHitEnum;

// ᡼
typedef struct {
  KXL_Image *img; // ᡼ǡ
  KXL_Rect r;     // Ƚ
} PixData;
typedef struct {
  int max;        // ᡼Υե졼
  PixData *data;  // ᡼
} Sprite;

// 饯
typedef struct {
  Bool   Active;     // ե饰
  Uint16 Attr;       // ̻
  Uint16 Target;     // å
  Uint8  Power;      // 
  Sint16 Hp;         // ѵ
  Uint16 Score;      // 
  Sint16 Cnt1;       // 󥿡1
  Sint16 Cnt2;       // 󥿡2
  Sint16 Cnt3;       // 󥿡3
  Sint16 Cnt4;       // 󥿡4
  Sint16 Cnt5;       // 󥿡5
  Uint8  Bomb;       // ȯμ
  Uint16 X, Y;       // ɸ
  Uint32 CntX, CntY; // ưɸ
  Sint16 AddX, AddY; // ư
  Uint8  FrameNo;    // ե졼ֹ
  Uint8  FrameMax;   // ե졼
  Sprite *Spr;       // ᡼
} CharacterData;

// 饯Хå
typedef struct {
  CharacterData Chr;
  void (*Draw)(CharacterData *my);
  RcHitEnum (*Move)(CharacterData *my);
  RcHitEnum (*Hit)(CharacterData *my, CharacterData *your);
} CharacterObject;

// δ
typedef struct {
  MainEnum MainFlag;     // ᥤư
  Uint16   Key;          // ϥ
 
  // ʬ
  CharacterObject *My;   // 饯Хå
  Uint8    MyNo;         // 饯
  Sint8    Life;         // ĵ
  Uint8    MainLevel;    // ᥤΥ٥
  Uint8    SubNo;        // ֹ
  Uint8    SubLevel;     // ٥
  
  // Ũ
  CharacterObject *Your; // 饯Хå
  Uint8    YourNo;       // 饯()
  Uint8    StageMax;     // иѥ
  Uint16   EnemyCnt;     // и

  // ط
  Uint16   BackMax;      // Կ
  Uint8    BackLine;     // 
  Uint8    BackAdd;      // ư

  Uint32   Score;        // 
  Uint32   HiScore;      // ϥ
  Uint32   OneUp;        //
  Uint8    Stage;        // ơ

  Uint16   Cnt;          // ΤΥ󥿡
} RootData;

// 󥭥󥰾
typedef struct {
  Uint32 Score;
  Uint8 Stage;
  Uint8 Name[16];
} RankingData;

// ơǡ
typedef struct {
  Uint16 Time;     // и
  Uint8  CreateNo; // No.
  Uint8  Max;      // и
  Uint16 Step;     // иֳֻ
  Uint16 StepTime; // иֳֻ
  Uint8  X[256];   // иʿ
  Uint8  Y[256];   // иľ
  Bool   Flag;     // ե饰
} StageData;

#endif
